
// #name = Tribes 2 Package
// #version = 1.00
// #date = February 7, 2003
// #author =Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@wildmail.com
// #web = http://www.planetstarsiege.com/pj
// #description = Package Support
// #acknowledgements = none
// #status = working

if(!isObject(PJPackageData))
    new ScriptObject(PJPackageData){};

// %packagedfunction = name of function packaged
// %function = function to call when the packaed function is executed
// %beforeafter = "before" or "after" execute function before or after parent

// addpackage("DispatchLaunchmode", "MyFunction", "before");
// addpackage("DispatchLaunchmode", "MyFunction2", "after");

function addpackage(%packagedfunction, %function, %beforeafter){

	PJPackageData.count[%packagedfunction @ %beforeafter]++;
	%temp = %packagedfunction @ %beforeafter @ PJPackageData.count[%packagedfunction @ %beforeafter];
	PJPackageData.funccall[%temp] = %function;
}

package PackageBeginning{

function DispatchLaunchMode(){

	for(%i = 1; %i <=  PJPackageData.count["DispatchLaunchmodebefore"]; %i++){
		%temp = PJPackageData.funccall["DispatchLaunchmodebefore" @ %i];
		call(%temp);
	}

	parent::DispatchLaunchMode();

	for(%i = 1; %i <=  PJPackageData.count["DispatchLaunchmodeafter"]; %i++){
		%temp = PJPackageData.funccall["DispatchLaunchmodeafter" @ %i];
		call(%temp);
	}
}

function DisconnectedCleanup(){

	for(%i = 1; %i <=  PJPackageData.count["DisconnectedCleanupbefore"]; %i++){
		%temp = PJPackageData.funccall["DisconnectedCleanupbefore" @ %i];
		call(%temp);
	}

	parent::DisconnectedCleanup();

	for(%i = 1; %i <=  PJPackageData.count["DisconnectedCleanupafter"]; %i++){
		%temp = PJPackageData.funccall["DisconnectedCleanupafter" @ %i];
		call(%temp);
	}
}

function Quit(){

	for(%i = 1; %i <=  PJPackageData.count["Quitbefore"]; %i++){
		%temp = PJPackageData.funccall["Quitbefore" @ %i];
		call(%temp);
	}

	parent::Quit();

	for(%i = 1; %i <=  PJPackageData.count["Quitafter"]; %i++){
		%temp = PJPackageData.funccall["Quitafter" @ %i];
		call(%temp);
	}
}

function PJSchemeTest::onWake(%this){

	for(%i = 1; %i <=  PJPackageData.count["PJSchemeTest::onWakebefore"]; %i++){
		%temp = PJPackageData.funccall["PJSchemeTest::onWakebefore" @ %i];
		call(%temp, %this);
//		error("PJSchemeTest::onWake before: " @ %temp @ " - " @ %this);
	}

	parent::onWake(%this);

	for(%i = 1; %i <=  PJPackageData.count["PJSchemeTest::onWakeafter"]; %i++){
		%temp = PJPackageData.funccall["PJSchemeTest::onWakeafter" @ %i];
		call(%temp, %this);
//		error("PJSchemeTest::onWake after: " @ %temp @ " - " @ %this);
	}
}

function clientCmdSetStationKeys(%inStation){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetStationKeysbefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetStationKeysbefore" @ %i];
		call(%temp, %inStation);
	}

	parent::clientCmdSetStationKeys(%inStation);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetStationKeysafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetStationKeysafter" @ %i];
		call(%temp, %inStation);
	}
}

function PlayGui::onWake(%this){

	for(%i = 1; %i <=  PJPackageData.count["PlayGui::onWakebefore"]; %i++){
		%temp = PJPackageData.funccall["PlayGui::onWakebefore" @ %i];
		call(%temp, %this);
	}

	parent::onWake(%this);

	for(%i = 1; %i <=  PJPackageData.count["PlayGui::onWakeafter"]; %i++){
		%temp = PJPackageData.funccall["PlayGui::onWakeafter" @ %i];
		call(%temp, %this);
	}
}

function PlayGui::onSleep(%this){

	for(%i = 1; %i <=  PJPackageData.count["PlayGui::onSleepbefore"]; %i++){
		%temp = PJPackageData.funccall["PlayGui::onSleepbefore" @ %i];
		call(%temp, %this);
	}

	parent::onSleep(%this);

	for(%i = 1; %i <=  PJPackageData.count["PlayGui::onSleepafter"]; %i++){
		%temp = PJPackageData.funccall["PlayGui::onSleepafter" @ %i];
		call(%temp, %this);
	}
}

};

activatepackage(PackageBeginning);


package PackageToAdd{

function ClientCmdDisplayHuds(){

	for(%i = 1; %i <=  PJPackageData.count["ClientCmdDisplayHudsbefore"]; %i++){
		%temp = PJPackageData.funccall["ClientCmdDisplayHudsbefore" @ %i];
		call(%temp);
	}

	parent::ClientCmdDisplayHuds();

	for(%i = 1; %i <=  PJPackageData.count["ClientCmdDisplayHudsafter"]; %i++){
		%temp = PJPackageData.funccall["ClientCmdDisplayHudsafter" @ %i];
		call(%temp);
	}
}

function clientCmdTogglePlayHuds(%val){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdTogglePlayHudsbefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdTogglePlayHudsbefore" @ %i];
		call(%temp, %val);
	}

	parent::clientCmdTogglePlayHuds(%val);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdTogglePlayHudsafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdTogglePlayHudsafter" @ %i];
		call(%temp, %val);
	}
}

function clientCmdSetAmmoHudCount(%amount){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetAmmoHudCountbefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetAmmoHudCountbefore" @ %i];
		call(%temp, %amount);
	}

	parent::clientCmdSetAmmoHudCount(%amount);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetAmmoHudCountafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetAmmoHudCountafter" @ %i];
		call(%temp, %amount);
	}
}


function clientCmdsetRepairPackIconOn(){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdsetRepairPackIconOnbefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdsetRepairPackIconOnbefore" @ %i];
		call(%temp);
	}

	parent::clientCmdsetRepairPackIconOn();

	for(%i = 1; %i <=  PJPackageData.count["clientCmdsetRepairPackIconOnafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdsetRepairPackIconOnafter" @ %i];
		call(%temp);
	}
}

function clientCmdsetRepairPackIconOff(){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdsetRepairPackIconOffbefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdsetRepairPackIconOffbefore" @ %i];
		call(%temp);
	}

	parent::clientCmdsetRepairPackIconOff();

	for(%i = 1; %i <=  PJPackageData.count["clientCmdsetRepairPackIconOffafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdsetRepairPackIconOffafter" @ %i];
		call(%temp);
	}
}

function PJSchemeManager::onSleep(%this){

	for(%i = 1; %i <=  PJPackageData.count["PJSchemeManager::onSleepbefore"]; %i++){
		%temp = PJPackageData.funccall["PJSchemeManager::onSleepbefore" @ %i];
		call(%temp, %this);
//		error("PJSchemeManager::onSleep before: " @ %temp @ " - " @ %this);
	}

	parent::onSleep(%this);

	for(%i = 1; %i <=  PJPackageData.count["PJSchemeManager::onSleepafter"]; %i++){
		%temp = PJPackageData.funccall["PJSchemeManager::onSleepafter" @ %i];
		call(%temp, %this);
//		error("PJSchemeManager::onSleep after: " @ %temp @ " - " @ %this);
	}
}

function PJTestScheme(){

	for(%i = 1; %i <=  PJPackageData.count["PJTestSchemebefore"]; %i++){
		%temp = PJPackageData.funccall["PJTestSchemebefore" @ %i];
		call(%temp);
//		error("PJTestScheme before: " @ %temp);
	}

	parent::PJTestScheme();

	for(%i = 1; %i <=  PJPackageData.count["PJTestSchemeafter"]; %i++){
		%temp = PJPackageData.funccall["PJTestSchemeafter" @ %i];
		call(%temp);
//		error("PJTestScheme after: " @ %temp);
	}
}

};

activatepackage(PackageToAdd);

package PackageMaster2{

function LoadingGui::onWake(%this){

	for(%i = 1; %i <=  PJPackageData.count["LoadingGui::onWakebefore"]; %i++){
		%temp = PJPackageData.funccall["LoadingGui::onWakebefore" @ %i];
		call(%temp, %this);
	}

	parent::onWake(%this);

	for(%i = 1; %i <=  PJPackageData.count["LoadingGui::onWakeafter"]; %i++){
		%temp = PJPackageData.funccall["LoadingGui::onWakeafter" @ %i];
		call(%temp, %this);
	}
}

function clientCmdSetWeaponsHudItem(%slot, %ammoAmount, %addItem){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudItembefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudItembefore" @ %i];
		call(%temp, %slot, %ammoAmount, %addItem);
	}

	parent::clientCmdSetWeaponsHudItem(%slot, %ammoAmount, %addItem);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudItemafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudItemafter" @ %i];
		call(%temp, %slot, %ammoAmount, %addItem);
	}
}

function clientCmdSetWeaponsHudAmmo(%slot, %ammoAmount){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudAmmobefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudAmmobefore" @ %i];
		call(%temp, %slot, %ammoAmount);
	}

	parent::clientCmdSetWeaponsHudAmmo(%slot, %ammoAmount);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudAmmoafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudAmmoafter" @ %i];
		call(%temp, %slot, %ammoAmount);
	}
}

function clientCmdSetWeaponsHudActive(%slot, %ret, %vis){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudActivebefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudActivebefore" @ %i];
		call(%temp, %slot, %ret, %vis);
	}

	parent::clientCmdSetWeaponsHudActive(%slot, %ret, %addItem);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdSetWeaponsHudActiveafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdSetWeaponsHudActiveafter" @ %i];
		call(%temp, %slot, %ret, %vis);
	}
}

function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10){

	for(%i = 1; %i <=  PJPackageData.count["clientCmdChatMessageannouncebefore"]; %i++){
		%temp = PJPackageData.funccall["clientCmdChatMessageannouncebefore" @ %i];
		%msgString = call(%temp, %sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);

	for(%i = 1; %i <=  PJPackageData.count["clientCmdChatMessageannounceafter"]; %i++){
		%temp = PJPackageData.funccall["clientCmdChatMessageannounceafter" @ %i];
		%msgString = call(%temp, %sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}
}

function OptionsDlg::onWake(%this){

	for(%i = 1; %i <=  PJPackageData.count["OptionsDlg::onWakebefore"]; %i++){
		%temp = PJPackageData.funccall["OptionsDlg::onWakebefore" @ %i];
		call(%temp, %this);
	}

	parent::onWake(%this);

	for(%i = 1; %i <=  PJPackageData.count["OptionsDlg::onWakeafter"]; %i++){
		%temp = PJPackageData.funccall["OptionsDlg::onWakeafter" @ %i];
		call(%temp, %this);
	}
}

function OptionsDlg::onSleep(%this){

	for(%i = 1; %i <=  PJPackageData.count["OptionsDlg::onSleepbefore"]; %i++){
		%temp = PJPackageData.funccall["OptionsDlg::onSleepbefore" @ %i];
		call(%temp, %this);
	}

	parent::onSleep(%this);

	for(%i = 1; %i <=  PJPackageData.count["OptionsDlg::onSleepafter"]; %i++){
		%temp = PJPackageData.funccall["OptionsDlg::onSleepafter" @ %i];
		call(%temp, %this);
	}
}

};

activatepackage(PackageMaster2);


package PackageMaster{

function StartSelectedDemo(){

	for(%i = 1; %i <=  PJPackageData.count["StartSelectedDemobefore"]; %i++){
		%temp = PJPackageData.funccall["StartSelectedDemobefore" @ %i];
		call(%temp);
	}

	parent::StartSelectedDemo();

	for(%i = 1; %i <=  PJPackageData.count["StartSelectedDemoafter"]; %i++){
		%temp = PJPackageData.funccall["StartSelectedDemoafter" @ %i];
		call(%temp);
	}
}

function demoPlaybackComplete(){

	for(%i = 1; %i <=  PJPackageData.count["demoPlaybackCompletebefore"]; %i++){
		%temp = PJPackageData.funccall["demoPlaybackCompletebefore" @ %i];
		call(%temp);
	}

	parent::demoPlaybackComplete();

	for(%i = 1; %i <=  PJPackageData.count["demoPlaybackCompleteafter"]; %i++){
		%temp = PJPackageData.funccall["demoPlaybackCompleteafter" @ %i];
		call(%temp);
	}
}

function stopDemoPlayback(){

	for(%i = 1; %i <=  PJPackageData.count["stopDemoPlaybackbefore"]; %i++){
		%temp = PJPackageData.funccall["stopDemoPlaybackbefore" @ %i];
		call(%temp);
	}

	parent::stopDemoPlayback();

	for(%i = 1; %i <=  PJPackageData.count["stopDemoPlaybackafter"]; %i++){
		%temp = PJPackageData.funccall["stopDemoPlaybackafter" @ %i];
		call(%temp);
	}
}

function setupdemoplaybackhuds(){

	for(%i = 1; %i <=  PJPackageData.count["setupdemoplaybackhudsbefore"]; %i++){
		%temp = PJPackageData.funccall["setupdemoplaybackhudsbefore" @ %i];
		call(%temp);
	}

	parent::setupdemoplaybackhuds();

	for(%i = 1; %i <=  PJPackageData.count["setupdemoplaybackhudsafter"]; %i++){
		%temp = PJPackageData.funccall["setupdemoplaybackhudsafter" @ %i];
		call(%temp);
	}
}

function lobbyLeaveGame(){

	for(%i = 1; %i <=  PJPackageData.count["lobbyLeaveGamebefore"]; %i++){
		%temp = PJPackageData.funccall["lobbyLeaveGamebefore" @ %i];
		call(%temp);
	}

	parent::lobbyLeaveGame();

	for(%i = 1; %i <=  PJPackageData.count["lobbyLeaveGameafter"]; %i++){
		%temp = PJPackageData.funccall["lobbyLeaveGameafter" @ %i];
		call(%temp);
	}
}

function LaunchToolbarDlg::onWake(%this){

	for(%i = 1; %i <=  PJPackageData.count["LaunchToolbarDlg::onWakebefore"]; %i++){
		%temp = PJPackageData.funccall["LaunchToolbarDlg::onWakebefore" @ %i];
		call(%temp, %this);
	}

	parent::onWake(%this);

	for(%i = 1; %i <=  PJPackageData.count["LaunchToolbarDlg::onWakeafter"]; %i++){
		%temp = PJPackageData.funccall["LaunchToolbarDlg::onWakeafter" @ %i];
		call(%temp, %this);
	}
}

function LaunchToolbarMenu::onSelect(%this, %id, %text){

	for(%i = 1; %i <=  PJPackageData.count["LaunchToolbarMenu::onSelectbefore"]; %i++){
		%temp = PJPackageData.funccall["LaunchToolbarMenu::onSelectbefore" @ %i];
		call(%temp, %this, %id, %text);
	}

	parent::onSelect(%this, %id, %addItem);

	for(%i = 1; %i <=  PJPackageData.count["LaunchToolbarMenu::onSelectafter"]; %i++){
		%temp = PJPackageData.funccall["LaunchToolbarMenu::onSelectafter" @ %i];
		call(%temp, %this, %id, %text);
	}
}


};

activatepackage(PackageMaster);
